train <- rbind(iris3[1:25,1:2,1],
               iris3[1:25,1:2,2],
               iris3[1:25,1:2,3])

cl <- factor(c(rep("AD",25), rep("MCI",25), rep("CN",25)))
require(MASS)

test <- expand.grid(x=seq(min(train[,1]-1), max(train[,1]+1),
                          by=5),
                    y=seq(min(train[,2]-1), max(train[,2]+1), 
                          by=5))
require(class)
classif <- knn(train, test, cl, k = 5, prob=TRUE)
prob <- attr(classif, "prob")
dataf <- bind_rows(mutate(test,
                          prob=prob,
                          class="CN",
                          prob_cls=ifelse(classif==class,
                                          1, 0)),
                   mutate(test,
                          prob=prob,
                          class="AD",
                          prob_cls=ifelse(classif==class,
                                          1, 0)))
ggplot(dataf) +
  geom_point(aes(x=x, y=y, col=class, size=prob),
             data = mutate(test, class=classif),fill = "dark grey", colour = "black", alpha = 1/3) + 
  scale_size(range=c(0.8, 2)) +
  geom_point(aes(x=x, y=y, shape=class),
             size=3,
             data=data.frame(x=train[,1], y=train[,2], class=cl))+
  geom_contour(aes(x=x, y=y, z=prob, group=class),
               bins=2,
               data=dataf,fill = "dark grey", colour = "black", alpha = 0.5)+
  labs(x = "ABETA142",y="TAU")